Package net.sf.saxon.expr.instruct

## Class FixedElement

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ParentNodeConstructor
      - - net.sf.saxon.expr.instruct.ElementCreator
        - - net.sf.saxon.expr.instruct.FixedElement

- All Implemented Interfaces:
    `ExportAgent`, `InstructionWithComplexContent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`

      public class FixedElement
      extends ElementCreator

  An instruction that creates an element node whose name is known statically. Used for literal results elements in XSLT, for direct element constructors in XQuery, and for xsl:element in cases where the name and namespace are known statically.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected NamespaceMap` | `namespaceBindings` |

    - ### Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `contentOp, preservingTypes`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FixedElement​(NodeName elementName, NamespaceMap namespaceBindings, boolean inheritNamespacesToChildren, boolean inheritNamespacesFromParent, SchemaType schemaType, int validation)` | Create an instruction that creates a new element node

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `checkContentSequence​(StaticContext env)` | Check statically whether the content of the element creates attributes or namespaces after creating any child nodes
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `void` | `gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)` | Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
    `NamespaceMap` | `getActiveNamespaces()` | Callback to get a list of the intrinsic namespaces that need to be generated for the element.
    `NodeName` | `getElementName()` |
    `NodeName` | `getElementName​(XPathContext context, NodeInfo copiedNode)` | Callback from the superclass ElementCreator to get the nameCode for the element name
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `ItemType` | `getItemType()` | Get the type of the item returned by this instruction
    `java.lang.String` | `getNewBaseURI​(XPathContext context, NodeInfo copiedNode)` | Get the base URI for the element being constructed
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `void` | `outputNamespaceNodes​(Outputter out, NodeName nodeName, NodeInfo copiedNode)` | Callback from the superclass ElementCreator to output the namespace nodes
    `Expression` | `simplify()` | Simplify an expression.
    `java.lang.String` | `toShortString()` | Produce a short string identifying the expression for use in error messages
    `java.lang.String` | `toString()` | The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator

      `computeSpecialProperties, getCardinality, getImplementationMethod, getStreamerName, isBequeathNamespacesToChildren, isInheritNamespacesFromParent, processLeavingTail, processLeavingTail, setBequeathNamespacesToChildren, setInheritanceFlags, setInheritNamespacesFromParent, suppressValidation`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `addToPathMap, allowExtractingCommonSubexpressions, alwaysCreatesNewNodes, computeCardinality, getContentExpression, getContentOperand, getSchemaType, getValidationAction, getValidationOptions, isLocal, isPreservingTypes, mayCreateNewNodes, setContentExpression, setNoNeedToStrip, setValidationAction, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, evaluateItem, getInstructionNameCode, getNetCost, getSourceLocator, isInstruction, isXSLT, iterate, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplifyChildren, staticTypeCheck, toPattern, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### namespaceBindings

          protected NamespaceMap namespaceBindings

  - ### Constructor Detail

    - #### FixedElement

          public FixedElement​(NodeName elementName,
                              NamespaceMap namespaceBindings,
                              boolean inheritNamespacesToChildren,
                              boolean inheritNamespacesFromParent,
                              SchemaType schemaType,
                              int validation)

      Create an instruction that creates a new element node
      Parameters:
        `elementName` - Represents the name of the element node
        `namespaceBindings` - List of namespaces to be added to the element node. Supply an empty array if none are required.
        `inheritNamespacesToChildren` - true if the children of this element inherit its namespaces
        `inheritNamespacesFromParent` - true if this element inherits namespaces from its parent
        `schemaType` - Type annotation for the new element node
        `validation` - Validation mode to be applied, for example STRICT, LAX, SKIP

  - ### Method Detail

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Specified by:
        `operands` in class `Instruction`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### simplify

          public Expression simplify()
                              throws XPathException

      Simplify an expression. This performs any context-independent rewriting
      Overrides:
        `simplify` in class `Expression`
      Returns:
        the simplified expression (or the original if unchanged, or if modified in-situ)
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### checkContentSequence

          protected void checkContentSequence​(StaticContext env)
                                       throws XPathException

      Check statically whether the content of the element creates attributes or namespaces after creating any child nodes
      Overrides:
        `checkContentSequence` in class `ElementCreator`
      Parameters:
        `env` - the static context
      Throws:
        `XPathException` - if the content sequence is invalid

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `ParentNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - a mutable list of (old binding, new binding) pairs that is used to update the bindings held in any local variable references that are copied.
      Returns:
        the copy of the original expression

    - #### getItemType

          public ItemType getItemType()

      Get the type of the item returned by this instruction
      Overrides:
        `getItemType` in class `ElementCreator`
      Returns:
        the item type

    - #### getElementName

          public NodeName getElementName​(XPathContext context,
                                         NodeInfo copiedNode)

      Callback from the superclass ElementCreator to get the nameCode for the element name
      Specified by:
        `getElementName` in class `ElementCreator`
      Parameters:
        `context` - The evaluation context (not used)
        `copiedNode` - For the benefit of the xsl:copy instruction, the node to be copied
      Returns:
        the name code for the element name

    - #### getElementName

          public NodeName getElementName()

    - #### gatherProperties

          public void gatherProperties​(java.util.function.BiConsumer<java.lang.String,​java.lang.Object> consumer)

      Get the properties of this object to be included in trace messages, by supplying the property values to a supplied consumer function
      Parameters:
        `consumer` - the function to which the properties should be supplied, as (property name, value) pairs.

    - #### getNewBaseURI

          public java.lang.String getNewBaseURI​(XPathContext context,
                                                NodeInfo copiedNode)

      Description copied from class: `ElementCreator`
      Get the base URI for the element being constructed
      Specified by:
        `getNewBaseURI` in class `ElementCreator`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `copiedNode` - the node being copied (for xsl:copy), otherwise null
      Returns:
        the base URI of the constructed element

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### outputNamespaceNodes

          public void outputNamespaceNodes​(Outputter out,
                                           NodeName nodeName,
                                           NodeInfo copiedNode)
                                    throws XPathException

      Callback from the superclass ElementCreator to output the namespace nodes
      Specified by:
        `outputNamespaceNodes` in class `ElementCreator`
      Parameters:
        `out` - The receiver to handle the output
        `nodeName` - the name of this element
        `copiedNode` - in the case of xsl:copy, the node being copied
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getActiveNamespaces

          public NamespaceMap getActiveNamespaces()

      Callback to get a list of the intrinsic namespaces that need to be generated for the element.
      Returns:
        the namespace bindings that must be generated for the new element node

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### toString

          public java.lang.String toString()

      Description copied from class: `Expression`

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.

      For subclasses of Expression that represent XPath expressions, the result should always be a string that parses as an XPath 3.0 expression. The expression produced should be equivalent to the original making certain assumptions about the static context. In general the expansion will make no assumptions about namespace bindings, except that (a) the prefix "xs" is used to refer to the XML Schema namespace, and (b) the default function namespace is assumed to be the "fn" namespace.

      In the case of XSLT instructions and XQuery expressions, the toString() method gives an abstracted view of the syntax that is not designed in general to be parseable.

      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### toShortString

          public java.lang.String toShortString()

      Description copied from class: `Expression`
      Produce a short string identifying the expression for use in error messages
      Overrides:
        `toShortString` in class `Expression`
      Returns:
        a short string, sufficient to identify the expression

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Instruction`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.